//+------------------------------------------------------------------+
//|                                              NewsTrader_v5.8.mq4 |
//|                        Copyright  2007-12, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-12, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

#import "kernel32.dll"
void GetLocalTime(int& TimeArray[]);
void GetSystemTime(int& TimeArray[]);
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//---- input parameters
extern string     ExpertName       = "NewsTrader_v5.8";

extern int        Magic            =    5858;
extern int        Slippage         =       3;

extern string     calInputs        = " Calendar settings: ";
extern int        CalendarID       =       4; // ID on calendar.forex-tsd.com  

extern string     timeInputs       = " Timing settings: ";
extern int        TimeGap          =       2; // Time Gap between News Time and Order Open Time in min 
extern int        OrderDuration    =      15; // Order Duratiton Time in min
extern int        ProcessTime      =       2; // Order processing Time in min
extern int        SessionEnd       =      23; // Session End Time
extern int        FridayEnd        =      22; // Session End Time in Friday

extern string     ordInputs        = " Order settings: ";
extern int        OrdersNum        =       2; // Number of pending orders from one side
extern double     PendOrdGap       =      15; // Gap for Pending Orders from current price in pips
extern double     OrdersStep       =      10; // Step between orders in pips
extern int        DelOpposite      =       1; // Switch of orders deleting: 0-off,1-on
extern int        TrailOpposite    =       1; // Trailing of Opposite Orders: 0-off,1-on

extern string     slInputs         = " StopLoss & TakeProfit settings: ";
extern double     InitialStop      =      30; // Initial Stop in pips
extern double     TakeProfit       =     100; // Take Profit in pips  
     	
extern string     trInputs         = " Trailing Stop & Breakeven settings: ";   
extern double     TrailingStop     =      15; // Trailing Stop in pips      
extern double     TrailingStep     =       0; // Trailing Stop Step in pips    
extern double     BreakEven        =       0; // Breakeven in pips  
extern double     PipsLock         =       0; // Lock in pips

extern string     adInputs         = " ECN and Straddle settings: ";   
extern bool       ECN_Mode         =   false; // ECN Mode 
extern bool       Straddle_Mode    =    true; // Straddle Mode 

extern string     dspInputs        = " Display settings: ";   
extern bool       DisplayLine      =    true; // Display Line Option (Visualization mode) 
extern bool       DisplayText      =   false; // Display Text Option (Visualization mode)
extern bool       DisplayLevels    =    true; // Display Levels for ECN Mode
extern int        LineStyle        =       3;
extern bool       CommentMode      =   false; // Comments Mode: 0-off,1-on(use only for Live Trading and Visual Testing)

extern string     CurrInputs       = " Currency Filter: ";
extern color      USD              =    Blue; // None-off,any Color-on
extern color      EUR              =    Pink; // None-off,any Color-on  
extern color      GBP              =     Red; // None-off,any Color-on  
extern color      JPY              =  Orange; // None-off,any Color-on
extern color      AUD              =   Green; // None-off,any Color-on
extern color      CAD              =  Tomato; // None-off,any Color-on
extern color      CHF              = Magenta; // None-off,any Color-on
extern color      NZD              =    Aqua; // None-off,any Color-on
extern color      CNY              =  Yellow; // None-off,any Color-on

extern string     rtngInputs       = " Rating Filter: ";
extern int        MaxRating        =       3;
extern int        MinRating        =       1;  

extern string     mmInputs         = " MoneyManagement settings: ";
extern bool       MM_mode          =   false; //  Switch
extern double     Lots             =     0.1; // Lot size
extern double     MaxRisk          =    0.04; // Risk Factor

datetime FinTime = 0;

string   sDate[];          // Date
string   sTime[];          // Time
string   sCurrency[];      // Currency
string   sDescription[];   // Description
string   sRating[];        // Rating
string   sActual[];        // Actual value
string   sForecast[];      // Forecast value
string   sPrevious[];      // Previous value
string   sImpact[];

datetime dt[];

double   BuyLevel[], SellLevel[]; 
int      BuyNum[], SellNum[];
int      BEvent=0, NewsNum, TriesNum=5, BuyEvent, SellEvent;
string   CalendarName;
bool     firstTime, NewEvent;
datetime prevWeekTime,OpenTime=0;
int      TimeZone = 0, pEventTime, ECN_Buy, ECN_Sell;
double   totalPips=0, totalProfits=0;
double   dRatio, contract, lot_min, lot_step, lot_max, tick_val, _Point, minstop, pAsk, pBid;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   dRatio   = MathPow(10,Digits%2);  
   lot_step = MarketInfo(Symbol(),MODE_LOTSTEP); 
   lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   contract = MarketInfo(Symbol(),MODE_LOTSIZE);   
   tick_val = MarketInfo(Symbol(),MODE_TICKVALUE)*dRatio;
   minstop  = MarketInfo(Symbol(),MODE_STOPLEVEL)/dRatio;
   _Point   = MarketInfo(Symbol(),MODE_POINT)*dRatio;
   
   ArrayResize(BuyLevel ,OrdersNum);
   ArrayResize(SellLevel,OrdersNum);
   ArrayResize(BuyNum ,OrdersNum);
   ArrayResize(SellNum,OrdersNum);
   pEventTime = TimeCurrent(); 
   firstTime = true;
//----
return(0);
}
  
// ---- Money Management
double MoneyManagement()
{
   
   double vol;
//--- check data
   if(lot_min < 0 || lot_max <= 0 || lot_step <= 0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }

//--- basic formula
   if(MM_mode) vol = NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2); else vol = Lots;
//--- check min, max and step
   vol = NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol < lot_min) vol = lot_min;
   if(vol > lot_max) vol = lot_max;
//---
   return(vol);
}   

// ---- Trailing Stops
void TrailStop(double ts,double step,double be,double pl)
{
   int    k, error, prevticket, total = OrdersTotal();  
   bool   result;
   double Gain, BuyStop, SellStop, price;
     
   
   
   for (int cnt=total-1;cnt>=0;cnt--)
   { 
   if(!OrderSelect(cnt, SELECT_BY_POS)) continue;  
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic) continue;             
   double open = OrderOpenPrice();
   double stop = OrderStopLoss();
      
      if(OrderType() == OP_BUY)
      { 
      Gain = 0; BuyStop = 0;
	   double _Bid = MarketInfo(Symbol(),MODE_BID);	   
               
         if(be > 0 && NormalizeDouble(stop - open,Digits) < NormalizeDouble(pl*_Point,Digits))
		   {
		   Gain = NormalizeDouble((_Bid - open)/_Point,Digits);   
         if(Gain >= be) BuyStop = NormalizeDouble(open + pl*_Point,Digits);
		   }
			else
			if(ts > 0 || step > 0) 
			{			   
			BuyStop = NormalizeDouble(_Bid - ts*_Point,Digits);
			   if(step > 0)
			   {
			   if(BuyStop >= NormalizeDouble(stop + step *_Point,Digits)) BuyStop = BuyStop; 
			   else BuyStop = OrderStopLoss();
			   }
			}			   			   
			
			if(BuyStop <= 0) continue; 
				   
			if(_Bid - BuyStop < minstop*_Point) BuyStop = NormalizeDouble(_Bid - minstop*_Point,Digits);   
              
			if(NormalizeDouble(OrderOpenPrice(),Digits) <= BuyStop) 
         {   
			   if(NormalizeDouble(BuyStop,Digits) > NormalizeDouble(stop,Digits) || stop == 0) 
			   {
			      for(k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),open,NormalizeDouble(BuyStop,Digits),OrderTakeProfit(),0,Lime);
               
               error=GetLastError();
               
                  if(error == 0 && result) break;
                  else 
                  if(error == 130 && !result)
                  {
                     while(!result)
                     {
                     BuyStop -= _Point;
                     RefreshRates();
                     //Print("BUY Trail: OOP=",OrderOpenPrice()," BS=",BuyStop," bid=",Bid);
                     result = OrderModify(OrderTicket(),open,BuyStop,OrderTakeProfit(),0,Lime);
                     }  
                  }
                  else {Sleep(5000); RefreshRates(); continue;}
                     		 
               }            
            }
         }
      }         
      else
      if(OrderType() == OP_SELL)
      {
      Gain = 0; SellStop = 0;
      double _Ask = MarketInfo(Symbol(),MODE_ASK);
   
         if(be > 0 && (NormalizeDouble(open - stop,Digits) < NormalizeDouble(pl*_Point,Digits) || stop == 0))
			{
			Gain = (open - _Ask)/_Point;
			if(Gain >= be) SellStop = NormalizeDouble(open - pl*_Point,Digits);
			}
			else
			if(ts > 0 || step > 0) 
			{			   
			SellStop = NormalizeDouble(_Ask + ts*_Point,Digits);
			   if(step > 0)
			   {
			   if(SellStop <= NormalizeDouble(stop - step *_Point,Digits)) SellStop = SellStop; 
			   else SellStop = stop;
			   }
         }
                       
         if(SellStop <= 0) continue;
                        
         if(SellStop - _Ask < minstop*_Point) SellStop = NormalizeDouble(_Ask + minstop*_Point,Digits);   
                        
         if(NormalizeDouble(open,Digits) >= SellStop && SellStop > 0) 
         {
            if(NormalizeDouble(SellStop,Digits) < NormalizeDouble(stop,Digits) || stop == 0) 
            {
               for( k = 0 ; k < TriesNum; k++)
               {
               result = OrderModify(OrderTicket(),open,NormalizeDouble(SellStop,Digits),OrderTakeProfit(),0,Orange);
                  
               error=GetLastError();
                  
                  if(error == 0 && result) break;
                  else 
                  if(error == 130 && !result)
                  {
                     while(!result)
                     {
                     SellStop += _Point;
                     RefreshRates();
                     
                     result = OrderModify(OrderTicket(),open,NormalizeDouble(SellStop,Digits),OrderTakeProfit(),0,Orange);
                     }  
                  }
                  else {Sleep(5000); RefreshRates(); continue;}
               }   
   			}	    
         }
      }
   }     
}


// ---- Open Sell Orders
int SellOrdOpen(int ord,double price,double sl,double tp,int num) 
{		     
   int ticket = 0;
   int tr = 1;
      
   while (ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend( Symbol(),ord,MoneyManagement(),
	                    NormalizeDouble(price,Digits),
	                    dRatio*Slippage,
	                    NormalizeDouble(sl,Digits),
	                    NormalizeDouble(tp,Digits),
	                    ExpertName+" SELL:"+num,Magic,0,Red);
      
      if(ticket > 0) 
      {
        
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         {
         Print("SELL order opened : ", OrderOpenPrice());
         SellNum[num-1] = 1;
         ECN_Sell = 0;
         }
      }
	   else 	
      if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)
      Print("SELL: OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
}

// ---- Open Buy Orders
int BuyOrdOpen(int ord,double price,double sl,double tp,int num)
{		     
   int ticket = 0;
   int tr = 1;
      
   while ( ticket <= 0 && tr <= TriesNum)
   {
   ticket = OrderSend(Symbol(),ord,MoneyManagement(),
	                   NormalizeDouble(price,Digits),
	                   dRatio*Slippage,
	                   NormalizeDouble(sl,Digits), 
	                   NormalizeDouble(tp,Digits),
	                   ExpertName+" BUY:"+num,Magic,0,Blue);
      
      if(ticket > 0) 
      {
         if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
         {
         Print("BUY order opened : ", OrderOpenPrice());
         BuyNum[num-1] = 1;
         ECN_Buy = 0;
         }
      }
      else 
	   if(ticket < 0)
	   { 	
      Sleep(5000);
      RefreshRates();
      tr += 1;
      if(GetLastError()>0)      
      Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
      }
   }   
   return(ticket);
} 

// ---- Scan Trades
int ScanTrades(int& buy,int& sell,int& buylimit,int& selllimit,int& buystop,int& sellstop)
{   
   buy = 0; sell = 0; buylimit = 0; selllimit = 0; buystop = 0; sellstop = 0;
     
   for(int cnt=0; cnt <OrdersTotal(); cnt++) 
   {        
   if(!OrderSelect(cnt, SELECT_BY_POS)) continue;            
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic) continue;  
      
      if(OrderType() == OP_BUY ) buy++;
      if(OrderType() == OP_SELL) sell++;         
      if(OrderType() == OP_BUYLIMIT ) buylimit++;
      if(OrderType() == OP_SELLLIMIT) selllimit++;
      if(OrderType() == OP_BUYSTOP ) buystop++;
      if(OrderType() == OP_SELLSTOP) sellstop++;        
      
   }
   
   return(buy+sell+buylimit+selllimit+buystop+sellstop);
}  

datetime FinishTime(int Duration)
{   
   int total = OrdersTotal();
   datetime firstTime=0;
         
   for(int i=0; i<total; i++) 
   {        
   OrderSelect(i, SELECT_BY_POS);            
   
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   firstTime=OrderOpenTime()+ Duration*60;
   }
   
   return(firstTime);
}

// Closing of Pending Orders      
void PendOrdDel(int mode)
{
   bool result = false;
   
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ( Symbol()==OrderSymbol() && OrderMagicNumber()==Magic)     
      {
         if((mode==0 || mode==1) && OrderType()==OP_BUYSTOP)
         {     
         result = OrderDelete(OrderTicket());
         if(!result) Print("BUYSTOP: OrderDelete failed with error #",GetLastError());
         }
         else
         if((mode==0 || mode==2) && OrderType()==OP_SELLSTOP)
         {     
         result = OrderDelete( OrderTicket() );  
         if(!result) Print("SELLSTOP: OrderDelete failed with error #",GetLastError());
         }
      }
   }
}    

//-----
void ReadnPlotCalendar(string fName)
{    
   int i, k, handle;
   bool rates = false;
   string sMon, sNum, date, time, DT;
   
   
   ArrayResize(sDate,0);
   ArrayResize(sTime,0);
   ArrayResize(sCurrency,0);
   ArrayResize(sDescription,0);
   ArrayResize(sRating,0);
   ArrayResize(sActual,0);
   ArrayResize(sForecast,0);
   ArrayResize(sPrevious,0);
      
   ArrayResize(dt,0);
   ArrayResize(sImpact,0);
    
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
   if(handle<1)
   {
   Print("File not found ", GetLastError());
   return(false);
   }
   else
   {
   i=0;
      while(!FileIsEnding(handle))
      {
      k = ArraySize(sDate);
   
      ArrayResize(sDate,k + 1);
      ArrayResize(sTime,k + 1);
      ArrayResize(sCurrency,k + 1);
      ArrayResize(sDescription,k + 1);
      ArrayResize(sRating,k + 1);
      ArrayResize(sActual,k + 1);
      ArrayResize(sForecast,k + 1);
      ArrayResize(sPrevious,k + 1);
            
      ArrayResize(dt,k + 1);
      ArrayResize(sImpact,k + 1);
      
      sDate[i]        = FileReadString(handle);   // Date
      sTime[i]        = FileReadString(handle);   // Time
      sCurrency[i]    = FileReadString(handle);   // Currency
      sDescription[i] = FileReadString(handle);   // Description
      sRating[i]      = FileReadString(handle);   // Rating
      sActual[i]      = FileReadString(handle);   // Actual value
      sForecast[i]    = FileReadString(handle);   // Forecast value
      sPrevious[i]    = FileReadString(handle);   // Previous value
 
      int rating = StrToInteger(sRating[i]);
      if(rating == 3) sImpact[i] = "H";
      if(rating == 2) sImpact[i] = "M";
      if(rating == 1) sImpact[i] = "L ";        
      
      rates = rating <= MaxRating && rating >= MinRating;
            
      if(!rates) continue;
      
      if(sCurrency[i] == "USD" && USD < 0) continue;            
      if(sCurrency[i] == "EUR" && EUR < 0) continue;            
      if(sCurrency[i] == "GBP" && GBP < 0) continue;                      
      if(sCurrency[i] == "JPY" && JPY < 0) continue;
      if(sCurrency[i] == "AUD" && AUD < 0) continue;
      if(sCurrency[i] == "CAD" && CAD < 0) continue;                     
      if(sCurrency[i] == "CHF" && CHF < 0) continue;  
      if(sCurrency[i] == "NZD" && NZD < 0) continue;   
      if(sCurrency[i] == "CNY" && CNY < 0) continue;   
      
      dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
            
      string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
        
      
      Print( info );
      
      
      color clr = White ;
   
      if(sCurrency[i] == "USD") clr = USD;  
      if(sCurrency[i] == "EUR") clr = EUR; 
      if(sCurrency[i] == "GBP") clr = GBP;
      if(sCurrency[i] == "JPY") clr = JPY;            
      if(sCurrency[i] == "AUD") clr = AUD;       
      if(sCurrency[i] == "CAD") clr = CAD;
      if(sCurrency[i] == "CHF") clr = CHF;
      if(sCurrency[i] == "NZD") clr = NZD;  
      if(sCurrency[i] == "CNY") clr = CNY; 
        
         
         if (DisplayText)
         {
         ObjectCreate("tsdT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
         ObjectSet("tsdT"+i, OBJPROP_COLOR, clr);          
         ObjectSetText("tsdT"+i,TimeToStr(dt[i])+ " " + sCurrency[i] + " " + sImpact[i] + " " + sDescription[i],8);          
         ObjectSet("tsdT"+i, OBJPROP_ANGLE, 90);          
         }
          
         if (DisplayLine)
         {         
         ObjectCreate("tsdL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
         ObjectSet("tsdL"+i, OBJPROP_COLOR, clr);                    
         ObjectSet("tsdL"+i, OBJPROP_STYLE, LineStyle);                    
         ObjectSet("tsdL"+i, OBJPROP_BACK, true);          
         ObjectSetText("tsdL"+i,TimeToStr(dt[i])+ " " + sCurrency[i] + " " + sImpact[i] + " " + sDescription[i],8);          
         }
  
      i++;
      }
   NewsNum = i;
   }
   return(0);
}
//----
void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "tsdL", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "tsdL", i ),"\" ) - Error #", _GetLastError );
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "tsdT", i ) ) )
      {
      _GetLastError = GetLastError();
      //Print( "ObjectDelete( \"", StringConcatenate( "tsdT", i ),"\" ) - Error #", _GetLastError );
      }
   }
}
//-----
void ArrowsDel()
{
   int _GetLastError;
   if(DisplayLevels) int obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if(DisplayLevels)
      {
         if(!ObjectDelete(StringConcatenate("bECNL", i))) 
         {
         _GetLastError = GetLastError();
         //Print( "ObjectDelete( \"", StringConcatenate( "bECNL", i ),"\" ) - Error #", _GetLastError );
         }
         
         if(!ObjectDelete(StringConcatenate("sECNL", i)))
         {
         _GetLastError = GetLastError();
         //Print( "ObjectDelete( \"", StringConcatenate( "sECNL", i ),"\" ) - Error #", _GetLastError );
         }
      }
   }     
}
//---- Close of Orders

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<=total; i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      ntr=0; 
      while (ntr<5 && !IsTradeAllowed()) { ntr++; Sleep(5000); }
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}
//------
int TimeToOpen()
{
   int result = 0;
      
   if(ECN_Mode) int ProcTime = OrderDuration;
   else ProcTime = ProcessTime;
   
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime oTime = dt[i] - TimeGap*60;
   
      if(TimeCurrent()>= oTime && TimeCurrent() <= oTime + ProcTime * 60 && oTime >= pEventTime)
      {
      result = oTime; 
      break;
      }
   }
      
   return(result);
}
//-----
bool IsNewEvent()
{
   bool result = false;
        
   for (int i=0; i < NewsNum; i++)
   { 
   datetime oTime = dt[i] - TimeGap*60;
   
      if(TimeCurrent()>= oTime && oTime > pEventTime)
      {
      result = true; 
      pEventTime = oTime;
      break;
      }
   }
   return(result);
}

//-----        
void TrailOppositeOrder(int mode)
{
   int    error;  
   bool   result=false;
   double Gain = 0;
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   if(!OrderSelect(cnt, SELECT_BY_POS)) continue;  
   if(OrderSymbol() != Symbol() || OrderMagicNumber() != Magic) continue; 
          
      if(mode == 1 && OrderType() == OP_BUYSTOP) 
      {
		double BuyPrice = MarketInfo(Symbol(),MODE_ASK);   
		
         for(int nt=1;nt<=OrdersNum;nt++)
         {
            if(VerifyComment(1,nt))
			   {
			   double mBuyPrice = BuyPrice + (2*PendOrdGap + OrdersStep*(nt - 1))*_Point;
		      if(InitialStop > 0) double mBuyStop   = mBuyPrice - InitialStop*_Point; else mBuyStop   = 0;
            if(TakeProfit  > 0) double mBuyProfit = mBuyPrice + TakeProfit *_Point; else mBuyProfit = 0; 
			   			     
               if(NormalizeDouble(OrderOpenPrice(),Digits) > NormalizeDouble(mBuyPrice,Digits) && OrderType() == OP_BUYSTOP) 
               {   
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),
                                       NormalizeDouble(mBuyPrice ,Digits),
                                       NormalizeDouble(mBuyStop  ,Digits),
			                              NormalizeDouble(mBuyProfit,Digits),0,Aqua);
                  
                  error = GetLastError();
                  
                     if(error == 0) break; 
                     else 
                     {
                     Print("Error trail BUYSTOP # ",OrderComment()," order=",OrderType(),"! Price=",DoubleToStr(mBuyPrice,Digits)," Stop=",DoubleToStr(mBuyStop,Digits)," Take=",DoubleToStr(mBuyProfit,Digits));  
                     Sleep(5000); 
                     RefreshRates(); 
                     continue;
                     }
                  }
               }            
            }
         }
      }
                  
// - SELL Orders          
      if (mode == 2 && OrderType() == OP_SELLSTOP)
      {
      double SellPrice = MarketInfo(Symbol(),MODE_BID);  
         
         for(nt=1;nt<=OrdersNum;nt++)
         {
            if(VerifyComment(2,nt))
			   {
            double mSellPrice = SellPrice - (2*PendOrdGap + OrdersStep*(nt - 1))*_Point;
            if(InitialStop > 0) double mSellStop   = mSellPrice + InitialStop*_Point; else mSellStop   = 0;
            if(TakeProfit  > 0) double mSellProfit = mSellPrice - TakeProfit *_Point; else mSellProfit = 0;  	   
         
               if(NormalizeDouble(OrderOpenPrice(),Digits) < NormalizeDouble(mSellPrice,Digits) && OrderType() == OP_SELLSTOP) 
               {
                  for(k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),
                                       NormalizeDouble(mSellPrice ,Digits),
			                              NormalizeDouble(mSellStop  ,Digits),
			                              NormalizeDouble(mSellProfit,Digits),0,Magenta);
                  
                  error  = GetLastError();
                  
                     if(error == 0) break; 
                     else 
                     {
                     Print("Error trail SELLSTOP # ",OrderComment()," order=",OrderType(),"! Price=",DoubleToStr(mSellPrice,Digits)," Stop=",DoubleToStr(mSellStop,Digits)," Take=",DoubleToStr(mSellProfit,Digits));  
                     Sleep(5000); 
                     RefreshRates(); 
                     continue;
                     }
                  }   
               }   
   			}	    
         }
      }
   }     
}

bool VerifyComment(int mode, int num)
{
   int total = OrdersTotal();
   bool result = false; 
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
      if ( OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
      {   
         if (mode==1 && OrderComment() == ExpertName+" BUY:"+num)  
         {
         result=true;
         break;
         }
      
         if (mode==2 && OrderComment() == ExpertName+" SELL:"+num) 
         {
         result=true;
         break;
         }
      }
   }
   
   return(result);
}                                   


string ForexTSD_Calendar()
{
   datetime StartWeek = iTime(NULL,PERIOD_W1,0); 
   
   string StartYear  = TimeYear (StartWeek);
   if(TimeMonth(StartWeek) > 9) string StartMonth = TimeMonth(StartWeek); else StartMonth = "0" + TimeMonth(StartWeek);
   if(TimeDay  (StartWeek) > 9) string StartDay   = TimeDay  (StartWeek); else StartDay   = "0" + TimeDay  (StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   
   string strHTM = "";
	
	bool result = GrabWeb(WebAdress,strHTM);
  
   if(result) 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, strHTM);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}
void ChartComment()
{
   
   string sComment   = "";
   string sp1        = "---------------------------------------------------\n";
   string NL         = "\n";
   string upcomNews  = "";
   string upcomTime  = "";
   string prevNews   = "";
   string prevTime   = "";
   string nextNews   = "";
   string nextTime   = "";
   
   TotalProfit();    
   int prTime = 0; 
   int upTime = 0;
   int nxTime = 0;
   
   for (int i=0; i <= NewsNum; i++)
   { 
      if((TimeCurrent() > dt[i-1] && TimeCurrent() <= dt[i]) || (upTime == dt[i] && TimeCurrent() <= dt[i]))
      {
         if(upTime == dt[i] && sDescription[i] != sDescription[i-1])   
         {
         upcomNews = upcomNews + (sCurrency[i] + "  " + sImpact[i] + "  " + sDescription[i] + NL); 
         upcomTime = TimeToStr(upTime);  
         }
         else
         {
         upcomNews = sCurrency[i] + "  " + sImpact[i] + "  " + sDescription[i] + NL; 
         upcomTime = TimeToStr(dt[i]);  
         }
      upTime = dt[i];
      }   
      
      if(TimeCurrent() > dt[i-1] && dt[i-1] != 0)
      {
         
         if(prTime == dt[i-1] && sDescription[i-1] != sDescription[i-2])   
         {
         
         prevNews = prevNews + (sCurrency[i-1]+"  " + sImpact[i-1] + "  " + sDescription[i-1] + NL); 
         prevTime = TimeToStr(prTime);
         }
         else
         {
         prevNews = sCurrency[i-1] + "  " + sImpact[i-1] + "  " + sDescription[i-1] + NL; 
         prevTime = TimeToStr(dt[i-1]);
         }
      
      if(i == 0) {prevNews =""; prevTime = "";}  
      prTime = dt[i-1];
      }
      
      if(upTime > 0 && upTime < dt[i])
      {
         if(dt[i] > nxTime && nxTime > 0) break;
         if(nxTime == dt[i] && sDescription[i] != sDescription[i-1])
         {      
         nextNews = nextNews + (sCurrency[i]+"  " + sImpact[i] + "  " +sDescription[i] + NL);
         nextTime = TimeToStr(nxTime);
         }
         else
         {
         nextNews = sCurrency[i]+"  " + sImpact[i] + "  " + sDescription[i] + NL;
         nextTime = TimeToStr(dt[i]);
         }
      nxTime = dt[i];
      }
   }
   
   int buy, sell, buylimit, selllimit, buystop, sellstop;
   int total = ScanTrades(buy, sell, buylimit, selllimit, buystop, sellstop);
   
   sComment = sp1;
   sComment = sComment + "ExpertName : " + ExpertName+NL;
   
   if(TimeZone >= 0)
   sComment = sComment + "Broker\'s Name :  "+AccountCompany()+ NL +"Time Zone : GMT + " + TimeZone + NL + sp1;
   else
   sComment = sComment + "Broker\'s Name :  "+AccountCompany()+ NL +"Time Zone : GMT - " + DoubleToStr(MathAbs(TimeZone),0) + NL + sp1;
   sComment = sComment + "Time: Current= " + TimeToStr(TimeCurrent()) + NL;
   sComment = sComment+"Orders: Open= "+(buy+sell)+" Pending= "+(buylimit+selllimit+buystop+sellstop)+" Total= "+total+NL;
   sComment = sComment + "Current Profit :  Pips = " + DoubleToStr(totalPips,2) + " " +AccountCurrency()+" = " + DoubleToStr(totalProfits,2) + NL + NL; 
   sComment = sComment + "  N E W S :" + NL + NL;
   sComment = sComment + "- Previous  :  "   + prevTime  + NL + sp1 + prevNews  + NL;
   sComment = sComment + "- Upcoming :  "    + upcomTime + NL + sp1 + upcomNews + NL;
   sComment = sComment + "- Next        :  " + nextTime  + NL + sp1 + nextNews  + NL;
   //sComment = sComment + "prevTime=" + TimeToStr(pEventTime) + " NewEvent=" + NewEvent + NL;   
   if(ECN_Mode)
   {
      if(OpenTime > 0)
      { 
      int mins = MathFloor(((OpenTime + OrderDuration*60) - TimeCurrent())/60.0);
      int secs = (((OpenTime + OrderDuration*60) - TimeCurrent())/60.0 - mins) * 60;
      
      if(mins < 10) string smins = StringConcatenate("0",mins);
      else smins = mins; 
      if(secs < 10) string ssecs = StringConcatenate("0",secs); 
      else ssecs = secs;
      
      sComment = sComment +  "ACTIVE from " + TimeToStr(OpenTime,TIME_SECONDS) +"  "+ smins +":"+ ssecs + " min left";
      }
      else 
      sComment = sComment +  "NOT ACTIVE";
   }
   
   Comment(sComment);
}      

void TotalProfit()
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic ) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/_Point);
            totalProfits += (OrderProfit() + OrderSwap() + OrderCommission());
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/_Point);
            totalProfits += (OrderProfit() + OrderSwap() + OrderCommission());
            break;
         }
      }            
	}
}

void ECN_StopAndProfit()
{
   int    error;  
   bool   result=false;
   double spread = Ask - Bid;
       
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if ((mode==OP_BUY || mode == OP_BUYLIMIT || mode == OP_BUYSTOP) && ECN_Buy != OrderTicket()) 
         {
			   if (InitialStop > 0) double BuyStop  = OrderOpenPrice() - InitialStop *_Point;
            else BuyStop = OrderStopLoss();
     
            if (TakeProfit  > 0) double BuyProfit= OrderOpenPrice() + TakeProfit*_Point;  
            else BuyProfit = OrderTakeProfit();  
			
			BuyStop = NormalizeDouble(BuyStop,Digits);
			BuyProfit = NormalizeDouble(BuyProfit,Digits);     
			   
			   if((OrderStopLoss() == 0 && BuyStop > 0) || (OrderTakeProfit() == 0 && BuyProfit > 0)) 
            {   
			      for(int k = 0 ; k < TriesNum; k++)
               {
               //Print("k=",k," BuyStop=",BuyStop); 
               result = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),Digits),
			                           BuyStop,
			                           BuyProfit,0,Lime);
               error=GetLastError();
                  if(error == 0) 
                  {
                  ECN_Buy = OrderTicket(); 
                  break;
                  }
                  else 
                  {
                  Print("BUY: OrderModify failed with error #",ErrorDescription(GetLastError()));
                  Sleep(5000); 
                  RefreshRates(); 
                  continue;
                  }
               }            
            }
         }   
// - SELL Orders          
         if ((mode==OP_SELL || mode == OP_SELLLIMIT || mode == OP_SELLSTOP) && ECN_Sell != OrderTicket())
         {
            if (InitialStop > 0) 
            double SellStop  = OrderOpenPrice() + InitialStop *_Point;
            else SellStop = OrderStopLoss();
	
            if (TakeProfit  > 0) double SellProfit = OrderOpenPrice() - TakeProfit*_Point; 
            else SellProfit=OrderTakeProfit();
			               
         SellStop = NormalizeDouble(SellStop,Digits);
			SellProfit = NormalizeDouble(SellProfit,Digits);    
            
            if((OrderStopLoss() == 0 && SellStop > 0) || (OrderTakeProfit() == 0 && SellProfit > 0)) 
            {
               
               for( k = 0 ; k < TriesNum; k++)
               {
               //Print("k=",k," SellStop=",SellStop); 
               result = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),Digits),
			                           SellStop,
			                           SellProfit,0,Orange);
               error=GetLastError();
                  if(error==0) 
                  {
                  ECN_Sell = OrderTicket(); 
                  break; 
                  }
                  else 
                  {
                  Print("SELL: OrderModify failed with error #",ErrorDescription(GetLastError()));
                  Sleep(5000); 
                  RefreshRates(); 
                  continue;
                  }
               }   
   			}	    
         }
      }
   }     
}


string GMT(int mode)
{  
   int    TimeArray[4];
   int    TZInfoArray[43];
   int    nYear,nMonth,nDay,nHour,nMin,nSec,nMilliSec;
   string sMilliSec, time_string;
//----
   if(mode == 0)
   {
   GetSystemTime(TimeArray);
//---- parse date and time from array
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TimeArray[0]>>16;
   nDay   = TimeArray[1]>>16;
   nHour  = TimeArray[2]&0x0000FFFF;
   nMin   = TimeArray[2]>>16;
   nSec   = TimeArray[3]&0x0000FFFF;
//---- format date and time items
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   return(time_string);
   }
   
//----
   if(mode > 0)
   {
   GetLocalTime(TimeArray);
//---- parse date and time from array
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TimeArray[0]>>16;
   nDay   = TimeArray[1]>>16;
   nHour  = TimeArray[2]&0x0000FFFF;
   nMin   = TimeArray[2]>>16;
   nSec   = TimeArray[3]&0x0000FFFF;
   
//---- format date and time items
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   
   if(mode == 1) return(time_string);
   
//---- shift with daylight savings
   int ret = GetTimeZoneInformation(TZInfoArray);
   int gmt_shift=0;
   
   if(ret != 0) gmt_shift = TZInfoArray[0];
   if(ret == 2) gmt_shift += TZInfoArray[42];
//---- GMT
   datetime local_time = StrToTime(time_string);
   
   time_string = TimeToStr(local_time+gmt_shift*60,TIME_DATE|TIME_SECONDS);
   
   if(mode == 2) return(time_string);
//---- winter time (nYear remains the current)
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TZInfoArray[17]>>16;
   nDay   = TZInfoArray[18]>>16;
   nHour  = TZInfoArray[19]&0x0000FFFF;
   nMin   = TZInfoArray[19]>>16;
   nSec   = TZInfoArray[20]&0x0000FFFF;
   
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   
   if(mode == 3) return(time_string);
//---- summer time (nYear remains the current)
   nYear  = TimeArray[0]&0x0000FFFF;
   nMonth = TZInfoArray[38]>>16;
   nDay   = TZInfoArray[39]>>16;
   nHour  = TZInfoArray[40]&0x0000FFFF;
   nMin   = TZInfoArray[40]>>16;
   nSec   = TZInfoArray[41]&0x0000FFFF;
   
   time_string = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);

   if(mode == 4) return(time_string);
//----
   }
}

string FormatDateTime(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec)
{
   string sMonth,sDay,sHour,sMin,sSec;
//----
   sMonth = 100 + nMonth;
   sMonth = StringSubstr(sMonth,1);
   sDay   = 100 + nDay;
   sDay   = StringSubstr(sDay,1);
   sHour  = 100 + nHour;
   sHour  = StringSubstr(sHour,1);
   sMin   = 100 + nMin;
   sMin   = StringSubstr(sMin,1);
   sSec   = 100 + nSec;
   sSec   = StringSubstr(sSec,1);
//----
   return(StringConcatenate(nYear,".",sMonth,".",sDay," ",sHour,":",sMin,":",sSec));
}



//+---------------------------------------------------------------------------+
//|                                                               WinInet.mqh |
//|                                                        Paul Hampton-Smith |
//|                                                        paul1000@pobox.com |
//|                                                                           |
//| This include has been adapted from the groundbreaking GrabWeb script      |
//| developed by Adbi that showed me how to import functions from wininet.dll |
//|---------------------------------------------------------------------------|
//|                                                               grabweb.mq4 |
//|                                                    Copyright  2006, Abhi |
//|                                         http://www.megadelfi.com/experts/ |
//|                                     E-mail: grabwebexpert{Q)megadelfi.com |
//|                                fix my e-mail address before mailing me ;) |
//+---------------------------------------------------------------------------+
// Main Webscraping function
// ~~~~~~~~~~~~~~~~~~~~~~~~~
// bool GrabWeb(string strUrl, string& strWebPage)
// returns the text of any webpage. Returns false on timeout or other error
bool bWinInetDebug = false;

int hSession_IEType;
int hSession_Direct;
int Internet_Open_Type_Preconfig = 0;
int Internet_Open_Type_Direct = 1;
int Internet_Open_Type_Proxy = 3;
int Buffer_LEN = 80;

#define INTERNET_FLAG_PRAGMA_NOCACHE    0x00000100 // Forces the request to be resolved by the origin server, even if a cached copy exists on the proxy.
#define INTERNET_FLAG_NO_CACHE_WRITE    0x04000000 // Does not add the returned entity to the cache. 
#define INTERNET_FLAG_RELOAD            0x80000000 // Forces a download of the requested file, object, or directory listing from the origin server, not from the cache.
#define INTERNET_FLAG_NO_COOKIES			 0x00080000 // Does not automatically add cookie headers to requests, and does not automatically add returned cookies to the cookie database.

#import "wininet.dll"
	int InternetOpenA(
		string 	sAgent,
		int		lAccessType,
		string 	sProxyName="",
		string 	sProxyBypass="",
		int 	lFlags=0
	);
	int InternetOpenUrlA(
		int 	hInternetSession,
		string 	sUrl, 
		string 	sHeaders="",
		int 	lHeadersLength=0,
		int 	lFlags=0,
		int 	lContext=0 
	);
	int InternetReadFile(
		int 	hFile,
		string 	sBuffer,
		int 	lNumBytesToRead,
		int& 	lNumberOfBytesRead[]
	);
	int InternetCloseHandle(
		int 	hInet
	);
#import


bool GrabWeb(string strUrl, string& strWebPage)
{
	int 		hInternet;
	int		iResult;
	int 		lReturn[]	= {1};
	string 	sBuffer		= "                                                                                                                                                                                                                                                               ";	// 255 spaces
	int 		bytes;
	
	hInternet = InternetOpenUrlA(hSession(FALSE), strUrl, "0", 0, 
								INTERNET_FLAG_NO_CACHE_WRITE | 
								INTERNET_FLAG_PRAGMA_NOCACHE | 
								INTERNET_FLAG_RELOAD			  |
								INTERNET_FLAG_NO_COOKIES, 0);

	if (bWinInetDebug) 
		Print("hInternet: " + hInternet);   
	if (hInternet == 0) 
		return(false);

	iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
	
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("lReturn: " + lReturn[0]);
	if (bWinInetDebug) 
		Print("iResult: " + iResult);
	if (bWinInetDebug) 
		Print("sBuffer: " +  sBuffer);
	if (iResult == 0) 
		return(false);
	bytes = lReturn[0];

	strWebPage = StringSubstr(sBuffer, 0, lReturn[0]);
	
// If there's more data then keep reading it into the buffer
	while (lReturn[0] != 0)
	{
		iResult = InternetReadFile(hInternet, sBuffer, Buffer_LEN, lReturn);
		if (lReturn[0]==0) 
			break;
		bytes = bytes + lReturn[0];
		strWebPage = strWebPage + StringSubstr(sBuffer, 0, lReturn[0]);
	}

	iResult = InternetCloseHandle(hInternet);
	if (iResult == 0) 
		return(false);
		
	return(true);
}

int hSession(bool Direct)
{
	string InternetAgent;

	if(hSession_IEType == 0)
	{
	InternetAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; Q312461)";
	hSession_IEType = InternetOpenA(InternetAgent, Internet_Open_Type_Preconfig, "0", "0", 0);
	hSession_Direct = InternetOpenA(InternetAgent, Internet_Open_Type_Direct, "0", "0", 0);
	}
	
	if(Direct) return(hSession_Direct); else return(hSession_IEType); 
}

               
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   ObjDel();
   ArrowsDel();
//----
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   //if(iBars(Symbol(),0) < 100) {Print("Bars=",iBars(Symbol(),0)," < 100!"); return(0);}
   if(GetLastError() == 134)   {Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0);}
   if(!IsTradeAllowed())    {Print("Trade is not allowed!"); return(0);}
   if(IsTradeContextBusy()) {Print("Trade context is busy. Please wait"); return(0);} 
//---- 
//---- 
   datetime currentWeekTime = iTime(NULL,PERIOD_W1,0);
  
   if(TimeCurrent() - currentWeekTime > PERIOD_W1*60) return(0);
 
   if (firstTime || (TimeCurrent() > currentWeekTime && currentWeekTime > prevWeekTime))
   {
   string gmt = GMT(0); 
     
   if(gmt != "") datetime gmtime = StrToTime(gmt); else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if(tz < 24) TimeZone = tz;
    
   CalendarName = ForexTSD_Calendar(); 
 
      if(CalendarName != "")
      {   
      ReadnPlotCalendar(CalendarName);
      firstTime = false;
      prevWeekTime = currentWeekTime;
      }
      else 
      {
      //Print("Attention! Wrong Calendar:",CalendarName,"time=",TimeToStr(TimeCurrent())); 
      return(0);
      }
   }
   
   int buy, sell, buylimit, selllimit, buystop, sellstop;
   int trades  = ScanTrades(buy, sell, buylimit, selllimit, buystop, sellstop);
   int open    = buy + sell;
   int pending = buylimit + buystop + selllimit + sellstop;
   
   
   NewEvent = IsNewEvent(); 
      
   if(trades > 0)
   {
      if(DelOpposite > 0)
      {
         if(buy  > 0) PendOrdDel(2); //while(ScanTrades(2,2) > 0) 
         if(sell > 0) PendOrdDel(1); //while(ScanTrades(1,2) > 0) 
          
         if(open == 0 && (buystop == 0 || sellstop == 0)) PendOrdDel(0);
      }      
      
      datetime FinTime = FinishTime(OrderDuration); 
      if (TimeCurrent() >= FinTime) PendOrdDel(0); //while(ScanTrades(0,2) > 0) 
      
      if(DayOfWeek()!=5) datetime EndTime = StrToTime(SessionEnd+":00")-Period()*60; 
      else EndTime = StrToTime(FridayEnd+":00")-Period()*60;
      
      bool EOD = false;
      EOD = TimeCurrent()>= EndTime;
      
      if (NewEvent || EOD)
      {
      CloseOrder(0); //while(ScanTrades(0,1) > 0) 
      PendOrdDel(0); //while(ScanTrades(0,2) > 0) 
      }
     
      if (ECN_Mode && trades > 0) ECN_StopAndProfit();
      
      if (open > 0 && (TrailingStop > 0 || BreakEven > 0)) TrailStop(TrailingStop,TrailingStep,BreakEven,PipsLock);
   
      if (TrailOpposite > 0 && DelOpposite == 0)
      {
      if (buy  > 0 && sellstop > 0) TrailOppositeOrder(2); 
      if (sell > 0 && buystop  > 0) TrailOppositeOrder(1);
      }   
   }
   
   if(ECN_Mode && NewEvent && trades < 1) 
   {
   BuyEvent  = 0; 
   SellEvent = 0; 
      
      for(int cnt=0;cnt < OrdersNum; cnt++)
      {
      BuyNum[cnt]  = 0;
      SellNum[cnt] = 0;    
      }   
   ArrowsDel();
   }
         
   if ((!ECN_Mode && trades < 1) || (ECN_Mode && trades < OrdersNum))
   { 
   OpenTime = TimeToOpen();
   
      if(OpenTime > 0)
      {
      double BuyPrice = MarketInfo(Symbol(),MODE_ASK);   
      double SellPrice= MarketInfo(Symbol(),MODE_BID);   
         for(cnt=1; cnt<=OrdersNum; cnt++)
         {
            if(!ECN_Mode)
		      {
		      double oBuyPrice = BuyPrice + (PendOrdGap+OrdersStep*(cnt-1))*_Point;
		      if (InitialStop > 0) double BuyStop =  oBuyPrice - InitialStop*_Point; else BuyStop=0;
            if (TakeProfit  > 0) double BuyProfit= oBuyPrice +  TakeProfit*_Point; else BuyProfit=0;   
            BuyOrdOpen(OP_BUYSTOP,oBuyPrice,BuyStop,BuyProfit,cnt); 
            }
            else
            if(ECN_Mode && ((!Straddle_Mode && sell == 0) || Straddle_Mode))
            {
            BuyStop=0; 
            BuyProfit=0;
               if(BuyEvent == 0)
               {
               BuyLevel[cnt-1] = BuyPrice + (PendOrdGap+OrdersStep*(cnt-1))*_Point;
                  if (DisplayLevels)
                  {         
                  ObjectCreate("bECNL"+cnt, OBJ_ARROW, 0, OpenTime,BuyLevel[cnt-1]);
                  ObjectSet("bECNL"+cnt, OBJPROP_ARROWCODE, 1);
                  ObjectSet("bECNL"+cnt, OBJPROP_COLOR, LightBlue);                    
                  ObjectSetText("bECNL"+cnt,Symbol() + " " + "Buy Level #" + cnt,8);          
                  }
               
               if(cnt == OrdersNum) BuyEvent = 1;
               } 
                              
               if(Ask >= BuyLevel[cnt-1] && pAsk < BuyLevel[cnt-1] && !VerifyComment(1,cnt) && BuyNum[cnt-1] == 0)
               { 
               BuyOrdOpen(OP_BUY,Ask,BuyStop,BuyProfit,cnt); 
               }
            }
         
            if(!ECN_Mode)
		      {
            double oSellPrice = SellPrice - (PendOrdGap+OrdersStep*(cnt-1))*_Point;
		      if (InitialStop > 0) double SellStop  = oSellPrice + InitialStop*_Point; else SellStop=0;
            if (TakeProfit  > 0) double SellProfit= oSellPrice - TakeProfit*_Point ; else SellProfit=0;
            SellOrdOpen(OP_SELLSTOP,oSellPrice,SellStop,SellProfit,cnt);
            }
            else
            if(ECN_Mode && ((!Straddle_Mode && buy == 0) || Straddle_Mode))
            {
            SellStop=0; 
            SellProfit=0;
               if(SellEvent == 0)
               {
               SellLevel[cnt-1] = SellPrice - (PendOrdGap+OrdersStep*(cnt-1))*_Point;
                  if (DisplayLevels)
                  {         
                  ObjectCreate("sECNL"+cnt, OBJ_ARROW, 0, OpenTime,SellLevel[cnt-1]);
                  ObjectSet("sECNL"+cnt, OBJPROP_ARROWCODE, 2); 
                  ObjectSet("sECNL"+cnt, OBJPROP_COLOR, Tomato);                    
                  ObjectSetText("sECNL"+cnt,Symbol() + " " + "Sell Level #" + cnt,8);          
                  }
               if(cnt == OrdersNum) SellEvent = 1;
               } 
               
               if(Bid <= SellLevel[cnt-1] && pBid > SellLevel[cnt-1] && !VerifyComment(2,cnt) && SellNum[cnt-1] == 0)
               { 
               SellOrdOpen(OP_SELL,Bid,SellStop,SellProfit,cnt);
               }
            }
         }
      }
   }
   
   if(CommentMode) ChartComment();
      
   pBid = Bid; 
   pAsk = Ask;  
      
   return(0);
}
//+------------------------------------------------------------------+





